/*
  Blank Simple Project.c
  http://learn.parallax.com/propeller-c-tutorials 
*/
#include "simpletools.h"                      // Include simple tools
#include "propeller.h"
#include "fdserial.h"

#define RmotorPin 17
#define DmotorPin 16
#define RdirPin 18
#define DdirPin 15
#define FDRX 0
#define FDTX 1

fdserial *trm;
terminal *dft;

fdserial *fd;
int b1, b2, b3, b4;
int ck;
int data;
char Buffer[32];
int i;

int main()                                    // Main function
{                                             // add startup code here
 low(RmotorPin);                               // <-- set pins as output
 low(DmotorPin);
 low(RdirPin);                                // <-- set default direction
 low(DdirPin);
 
 clkset(0x6b,5000000);
 simpleterm_close();
 trm = fdserial_open(31,30,0,115200);
 dft = fdserial_open(0,1,0,115200);
 pause(100);
 pwm_start(600);                              // <--generate a pulse every 600ms
    //pwm_start(2000);
    
 dprint(trm,"%d,%d,%d,%d\n",Buffer[0],Buffer[1],Buffer[2],Buffer[3]);
 
 i = 0;
 
 
 while(1)
  { 
   i = fdserial_rxCheck(trm);
   if(i > 0)
   fdserial_txChar(dft,i);
   
   i = fdserial_rxCheck(dft);
   if(i > 0)
   fdserial_txChar(trm,i);
                                          // Add main loop code here.
   ck = fdserial_rxCount(fd);               // <-- if we have serial data use it
   
   while(fdserial_rxCount(fd) > 0)
    {
      Buffer[i++] = fdserial_rxChar(fd);    // <-- capture one of the four bytes
      pause(5);
    }
    if(i > 0)
    {
      if(i == 4)
        data = 'A';
      else
        data = ' ';
        i = 0;
        dprint ("%d, %d,  %d, %d\n", Buffer[0], Buffer[1], Buffer[2],  Buffer[3]);
   }
   b1 = input(3);
   b2 = input(4);
   b3 = input(5);
   b4 = input(7);
   
   if (b1 == 1)
     data = 'W';
     
   if(b2 == 1)
     data = 'N';
   
   if(b3 == 1)
     data =  'E';
     
   if(b4 == 1)
     data = 'S';
     
   switch(data)
    {
      case 'W':
        high(RdirPin);
        pwm_set(RmotorPin, 0, 450);
        if(b1 == 0)
        data = ' ';
        break;
        
      case 'N':
        high(DdirPin);
        pwm_set(DmotorPin, 1, 450);
        if(b2 == 0)
          data = ' ';
        break;
          
      case 'E':
        
        low(RdirPin);
        pwm_set(RmotorPin, 0, 450);
        if(b3 == 0)
          data = ' ';
        break;
        
      case 'S':
      
        low(DdirPin);
        pwm_set(DmotorPin, 1,450);
        if(b4 == 0)
          data = ' ';
        break; 
        
      case 'A':
      
        set_output(RdirPin, Buffer[1]);
        set_output(DdirPin, Buffer[3]); 
        pwm_set(RmotorPin, 0, Buffer[0]);
        pwm_set(DmotorPin, 1, Buffer[2]);
        break;
        
      default:
      
        pwm_set(RmotorPin, 0, 55);
        pwm_set(DmotorPin, 1, 0);
        low(RdirPin);
        low(DdirPin);
        break;
    } 
    
      printi("%d, %d, %d, %d\n", Buffer[0], Buffer[1], Buffer[2], Buffer[3]);
             
      pause(10);
  }  
}
